#ifndef LB_VDW_H
#define LB_VDW_H

#include <lb-macros.h>

LB_BEGIN_DECLS

typedef struct {
	double T;
	double a;
	double b;
	double K;
	double tau;
} LBVdWParameters;

double lb_VdW_pressure_2d(const LBVdWParameters*,
			    const double* rho,
			    const double* drx,
			    const double* dry,
			    const double* ddr);

void lb_d2q9_VdW_equilibrium(const LBVdWParameters*,
			       const double* rho_ux_uy,
			       const double* drx,
			       const double* dry,
			       const double* ddr,
			       double equilibrium_pdfs[9]);

double lb_VdW_pressure_3d(const LBVdWParameters*,
			    const double* rho,
			    const double* drx,
			    const double* dry,
			    const double* drz,
			    const double* ddr);

void lb_d3q19_VdW_equilibrium(const LBVdWParameters*,
			        const double* rho,
				const double* u,
			        const double* drx,
			        const double* dry,
			        const double* drz,
			        const double* ddr,
			        double equilibrium_pdfs[19]);

LB_END_DECLS

#endif /* LB_VDW_H */
