#ifndef LB_COLORMAP_H
#define LB_COLORMAP_H

#include <lb-macros.h>

LB_BEGIN_DECLS

typedef struct _LBColormap LBColormap;

LBColormap* lb_colormap_new(void);
void lb_colormap_destroy(LBColormap*);

int lb_colormap_num_colors(const LBColormap*);

void lb_colormap_get_color(const LBColormap*, int, double c[3]);
void lb_colormap_set_color(LBColormap*, int, const double c[3]);
void lb_colormap_append_color(LBColormap*, const double c[3]);

void lb_colormap_map_value(const LBColormap*, double, double c[3]);

LB_END_DECLS

#endif /* LB_COLORMAP_H */
