#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include "lb-messages.h"
#include "lblua-utils.h"
#include "lua-lb-common.h"

void
lua_push_lb_partition_info(lua_State* ls, const LBPartitionInfo* info)
{
	lb_assert(ls != NULL);
	lb_assert(info != NULL);

	lua_newtable(ls);

	lua_pushstring(ls, "ndims");
	lua_pushnumber(ls, info->ndims);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "processor_rank");
	lua_pushnumber(ls, info->processor_rank);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "processors_size");
	lblua_push_array_int(ls, info->ndims, info->processors_size);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "processor_coords");
	lblua_push_array_int(ls, info->ndims, info->processor_coords);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "size");
	lblua_push_array_int(ls, info->ndims, info->size);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "periods");
	lblua_push_array_int(ls, info->ndims, info->periods);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "global_size");
	lblua_push_array_int(ls, info->ndims, info->global_size);
	lua_rawset(ls, -3);

	lua_pushstring(ls, "global_origin");
	lblua_push_array_int(ls, info->ndims, info->global_origin);
	lua_rawset(ls, -3);
}
